var idioma=$.rup.lang;
var configMsgEspera = {
		centerX : true,
		centerY : false,
		css : {
			width : "430px",
			height : "120px",
			top : "240px",
			textAlign : "center",
			backgroundColor : "#FFFFFF",
			color : "#666666",
			cursor : "wait"
		},
		overlayCSS : {
			backgroundColor : '#131313',
			opacity : 0.6
		},
		message : getJQueryWaitWindowMsg(jQuery.rup.i18n.app.comun.msgCargando)
	};
jQuery(function($){
	$("#dialogoEsperaModificacionEspecial").hide();
	
	//Combo usuarios expedientes
	$("#crespo20pre_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "500",
		blank: "",
		selected:""
	});
	
	
	
	//Campos fechas
	$.rup_date({		
		from: "faper20_desde_filter_table",
		to: "faper20_hasta_filter_table",
		//Resto igual que en date
		labelMaskId : "intervalo-mask",
		numberOfMonths: 2
	});
	$.rup_date({		
		from: "fcier20_desde_filter_table",
		to: "fcier20_hasta_filter_table",
		//Resto igual que en date
		labelMaskId : "intervalo-mask",
		numberOfMonths: 2
	});
	$.rup_date({		
		from: "fvto20_desde_filter_table",
		to: "fvto20_hasta_filter_table",
		//Resto igual que en date
		labelMaskId : "intervalo-mask",
		numberOfMonths: 2
	});
	
	//Tabla grid expedientes
	$("#ModificacionEspecial").rup_table({
		rowNum:20,
		url: "../aa21b20s01",
		colNames: [
		    "",
		    "id",
			"cserv20",
			$.rup.i18n.app.aa21b20s01.cexpe20,
			$.rup.i18n.app.aa21b20s01.cexpe20,
			"aexpe20",
			"nexpe20",
			$.rup.i18n.app.aa21b20s01.objeto20,
			$.rup.i18n.app.aa21b20s01.faper20,
			$.rup.i18n.app.aa21b20s01.fcier20,
			"refer20",
			"crespo20",
			"cpais20",
			"cprov20",
			"cmuni20",
			"obser20",
			"moneda20",
			"eimpor20",
			"pimpor20",
			"eimpora20",
			"pimpora20",
			"cdepar20",
			"carchi20",
			"ubica20",
			$.rup.i18n.app.aa21b20s01.cesta20,
			$.rup.i18n.app.aa21b20s01.cesta20,
			"fvto20"
		],
		colModel: [
		    {
		        name: "activo",
		        index: "activo",
		        width: "30",
		        formatter: "actions",
		        align: "center",
		        sortable: false,
		        classes : "ui-ellipsis"
		    },       
           { 	
		    	name: "idExpe", 
 				label: "idExpe",
				hidden: true 
			},       
			{ 	name: "cserv20", 
			 	label: "cserv20",
				hidden: true 
			},
			{ 	name: "refExp", 
			 	label: "refExp",
				align: "left", 
				width: 150, 
				editable: true, 
				fixed: false, 
				hidden: false, 
				resizable: true, 
				sortable: true
			},
			{ 	name: "cexpe20", 
			 	label: $.rup.i18n.app.aa21b20s01.cexpe20,
				hidden: true 
			},
			{ 	name: "aexpe20", 
			 	label: "aexpe20",
				hidden: true 
			},
			{ 	name: "nexpe20", 
			 	label: "nexpe20",
				hidden: true 
			},
			{ 	name: "objeto20", 
			 	label: $.rup.i18n.app.aa21b20s01.objeto20,
				align: "left", 
				width: 150, 
				editable: true, 
				fixed: false, 
				hidden: false, 
				resizable: true, 
				sortable: true
			},
			{ 	name: "faper20", 
			 	label: $.rup.i18n.app.aa21b20s01.faper20,
				align: "left", 
				width: 150, 
				editable: true, 
				fixed: false, 
				hidden: false, 
				resizable: true, 
				sortable: true
			},
			
			{ 	name: "fcier20", 
			 	label: $.rup.i18n.app.aa21b20s01.fcier20,
				align: "left", 
				width: 150, 
				editable: true, 
				ruptype: "datepicker", 
				fixed: false, 
				hidden: false, 
				resizable: true, 
				sortable: true
			},
			{ 	name: "refer20", 
			 	label: "refer20",
				hidden: true 
			},
			{ 	name: "crespo20", 
			 	label: "crespo20",
				hidden: true 
			},
			{ 	name: "cpais20", 
			 	label: "cpais20",
				hidden: true 
			},
			{ 	name: "cprov20", 
			 	label: "cprov20",
				hidden: true 
			},
			{ 	name: "cmuni20", 
			 	label: "cmuni20",
				hidden: true 
			},
			{ 	name: "obser20", 
			 	label: "obser20",
				hidden: true 
			},
			{ 	name: "moneda20", 
			 	label: "moneda20",
				hidden: true 
			},
			{ 	name: "eimpor20", 
			 	label: "eimpor20",
				hidden: true 
			},
			{ 	name: "pimpor20", 
			 	label: "pimpor20",
				hidden: true 
			},
			{ 	name: "eimpora20", 
			 	label: "eimpora20",
				hidden: true 
			},
			{ 	name: "pimpora20", 
			 	label: "pimpora20",
				hidden: true 
			},
			{ 	name: "cdepar20", 
			 	label: "cdepar20",
				hidden: true 
			},
			{ 	name: "carchi20", 
			 	label: "carchi20",
				hidden: true 
			},
			{ 	name: "ubica20", 
			 	label: "ubica20",
				hidden: true 
			},
			{ 	name: "cesta20", 
			 	label: $.rup.i18n.app.aa21b20s01.cesta20,
				hidden: true 
			},
			{ 	
				name: idioma=="es"?"desta":"eesta", 
			 	label: idioma=="es"?"desta":"eesta", 
				align: "left", 
				width: 150, 
				editable: true, 
				fixed: false, 
				hidden: true, 
				resizable: true, 
				sortable: true
			},
			{ 	name: "fvto20", 
			 	label: "fvto20",
				hidden: true 
			}
        ],

        model:"Aa21b20s01",
        usePlugins:[
			"formEdit",
        	"feedback",
			"toolbar",
        	"fluid",
        	"filter"
         	],
		primaryKey: "idExpe",
		sortname: "faper20",
		sortorder: "desc",
		loadOnStartUp: false,
		toolbar:{
			newButtons:[
	            
	            /*,
	            {
	            	id:"filtrar",
	            	obj: {id:"filtrar",i18nCaption:$.rup.i18n.app.botonerasMantGenerales.filtrar, css: "filtrar"},
	            	comportamiento:"add",
	            	click: function(){
	            		$("#Expedientes").rup_table("toggleFilterForm");
	            	}
	            }*/]
		},
		afterInsertRow : function(rowid, rowdata) {
			//Función que pinta en el registro Alta o Baja según sea A o B
			pintarFilaSituacionExpediente(rowid, rowdata, $(this), "cesta20");
		},
        formEdit:{
        	detailForm: "#ModificacionEspecial_detail_div",
			fillDataMethod: "clientSide",
         	validate:{ 
    			rules:{
    				"cserv20":{
						required: true
    					},
    				"cexpe20":{
						required: false
    					},
    				"aexpe20":{
						required: true
    					},
    				"nexpe20":{
						required: true
    					},
    				"faper20":{
						required: true
    					},
    				"objeto20":{
						required: true
    					},
    				"fcier20":{
						required: false
    					},
    				"refer20":{
						required: false
    					},
    				"crespo20":{
						required: true
    					},
    				"cpais20":{
						required: false
    					},
    				"cprov20":{
						required: false
    					},
    				"cmuni20":{
						required: false
    					},
    				"obser20":{
						required: false
    					},
    				"moneda20":{
						required: false
    					},
    				"eimpor20":{
						required: false
    					},
    				"pimpor20":{
						required: false
    					},
    				"eimpora20":{
						required: false
    					},
    				"pimpora20":{
						required: false
    					},
    				"cdepar20":{
						required: false
    					},
    				"carchi20":{
						required: false
    					},
    				"ubica20":{
						required: false
    					},
    				"cesta20":{
						required: false
    					},
    				"fvto20":{
						required: false
    					}
    				}
    		}
        },
        onPaging: function(){
			$("#ModificacionEspecial").rup_table("deselectAllRows");
		}
	});
	
	//Combo tipos expedientes
	$("#cexpe20_filter_table").rup_combo(
	{
		loadFromSelect: true,
		width: "500",
		blank: "",
		selected: "",
		ordered: true //20160905 - INIGO
	});
	
	$("#cexpe20_cambio").rup_combo(
			{
				loadFromSelect:true,
				width : "500"
				
			});
	//Combo usuarios expedientes
	$("#crespo20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "530",
		blank: "",
		selected:""
	});

	//Combo estados expedientes
	$("#cesta20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "150",
		blank: "",
		selected:""
	});
	
	//Combo ubicacion expedientes
	$("#carchi20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "210",
		blank: "",
		selected:""
	});
	
	//Combo departamentos expedientes
	$("#depar20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "530",
		blank: "",
		selected:""
	});
	
	//Combo paises 
	$("#cpais20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "180",
		blank: "",
		selected:"",
		change:function(){
			if($("#cpais20_filter_table").rup_combo("getRupValue") == 108){
				$("#divProvinciaFilter").show();
				$("#divMunicipioFilter").show();
			}else{
				$("#divProvinciaFilter").hide();
				$("#cprov20_filter_table").val("");
				$("#divMunicipioFilter").hide();
				//$("#cmuni20_filter_table").val("");
				$("#cmuni20_buscable").val("");
			}
		}
	});
	
	//Combo provincias 
	$("#cprov20_filter_table").rup_combo(
	{
		loadFromSelect:true,
		width : "180",
		blank: "",
		selected:""
	});
	
	//Angel 21/05/2019 - Cambiar combo Municipios por autocomplete
	//Combo municipios
	/*
	$("#cmuni20_filter_table").rup_combo({
		source : "../nora/municipioExp",
		sourceParam : {label:"dsO", value:"id"},
		parent: ["cprov20_filter_table"],
		width : "530",
		blank : ""
	});
	*/
	
	$("#cmuni20_buscable").rup_autocomplete({
		source : "../nora/municipioExpAutocomplete",
		sourceParam : {label:"dsO", value:"id"},
		extraParams: {
			cprov20: function() {return jQuery("#cprov20_filter_table").val();}
	     },
		method : 'GET',
		width: "100",
		getText:false,
		minLength : "3",
		change : function() {
			
		}
	});
	
	//Ya que no voy a utilizar el formulario de editar y añadir de UDA, asigno
	//a los botones añadir y editar mis funciones.
	$("[id='ModificacionEspecial_toolbar##"+$.rup.i18n.base.rup_maint.edit+"']").click(handlerModificarExpedienteEsp);
	//Ocultamos el botón de clonar y el de eliminar
	$("[id='ModificacionEspecial_toolbar##"+$.rup.i18n.base.rup_maint.new+"']").css("display","none");
	$("[id='ModificacionEspecial_toolbar##"+$.rup.i18n.base.rup_maint.clone+"']").css("display","none");
	$("[id='ModificacionEspecial_toolbar##"+$.rup.i18n.app.botonerasMantGenerales.eliminar+"']").css("display","none");
	
	//Deshabilito las funciones por defecto de UDA
	$("#ModificacionEspecial").on("rupTable_beforeAddRow", function(deleteOptions,selectedRow){
		return false;
	});
	$("#ModificacionEspecial").on("rupTable_beforeEditRow", function(deleteOptions,selectedRow){
		
		return false;
	});
	jQuery("#ModificacionEspecial").on("jqGridDblClickRow", function(event, form, oper) {
		return false;
	});
	
	$("#ModificacionEspecial_filter_filterButton2").on("click",function(event) {
		$("#ModificacionEspecial_filter_filterButton").click();
	});
	
	$("#ModificacionEspecial_filter_cleanLink2").on("click",function(event) {
		$("#ModificacionEspecial_filter_cleanLink").click();
	});
	

	
	$("#ModificacionEspecial_filter_cleanLink").unbind("click");
	$("#ModificacionEspecial_filter_cleanLink").click(limpiarExpedientesEsp);
	
	var properties = {
		type: "ok",
		delay: defaultDelay,
		fadeSpeed: 600,
		block: false,
		closeLink: true
	}
	$("#ModificacionEspecial_feedback").rup_feedback (properties);
	
	dialogoDetalleModificacionEspecial.ocultarElementos();
	dialogoDetalleModificacionEspecial.inicializar();
	
	/**
	 * Cambio de títulos y textos filtrar
	 */
	$("#ModificacionEspecial_filter_toggle_label").text($.rup.i18n.app.comun.critBusq);
	$("#ModificacionEspecial_filter_filterButton").val($.rup.i18n.app.comun.buscar);
	
	
	
	jQuery("#dialogoModificacionEspecialDetalle").on("dialogclose", function() {
		$("#ModificacionEspecial").rup_table("filter");
	});
	
	
	$("#ModificacionEspecial_cb div").hide();
	
	
	$("#ModificacionEspecial_filter_filterButton").click(function(){
		if($("#ModificacionEspecial_filter_fieldset").css("display") == "block"){
			$("#ModificacionEspecial").rup_table("toggleFilterForm");
		}	
	});
	
	$("#ModificacionEspecial").rup_table("toggleFilterForm");
	
});


function handlerModificarExpedienteEsp(){
	
$("#dialogoEsperaModificacionEspecial").show();
	
	if($("#ModificacionEspecial").rup_table("getSelectedRows") != ""){
		var registros = $("#ModificacionEspecial").rup_table("getSelectedLines");
	
		if(registros.length == 1){
			var indice = registros;
			var expediente = $("#ModificacionEspecial").rup_table("getRowData")[indice];
			if(expediente.cesta20 != "4"){
				var bloqueado =  bloquear("edit", $("#ModificacionEspecial"), "aa21b20s01", "objeto20");
				if(bloqueado){
					dialogoDetalleModificacionEspecial.ocultarElementos();
					dialogoDetalleModificacionEspecial.abrirExpediente(expediente,"M");
					
				}else{
					
					return bloqueado;
				}
			}	
		}else{
			
			$.rup_messages("msgAlert", {message: $.rup.i18n.app.mensajesMantGenerales.seleccionFila});
		}
	}else{
	
		$.rup_messages("msgAlert", {message: $.rup.i18n.app.mensajesMantGenerales.seleccionFila});
	}
	$("#dialogoEsperaModificacionEspecial").hide();
}

function limpiarExpedientesEsp() {
	$("#ModificacionEspecial").rup_table("clearGridData",true);
	$("#ModificacionEspecial_filter_summary").html("<i></i>");
	$("#ModificacionEspecial").rup_table("resetForm", $("#ModificacionEspecial_filter_form"));
	$("#cexpe20_filter_table").rup_combo("setRupValue","");
	$("#servicioLogueado").val($("#servicioLogueadoAux").val());
	try {
		$("#crespo20_filter_table").rup_combo("setRupValue",$("#crespo20pre_filter_table").val());
	} catch(e) {
		$("#crespo20_filter_table").rup_combo("setRupValue","");
	}
}

//visualizar icono documento en grid
//mostrar imagen en grid
$.fn.fmatter.actions = function(cellval, opts, rwd) {
	var str = '';
	//En el campo situación ponemos la imagen dependiendo de 
	//1º si el expediente esta cerrado
	//2º si el expediente esta cerrado no incluido
	//3º si el expediente esta de baja
	if (opts.colModel.name == 'activo') {
		var op = {
				keys : false,
				editbutton : false,
				delbutton : false,
				editformbutton : false,
				activoButton : true
		};
		if (!jQuery.fmatter.isUndefined(opts.colModel.formatoptions)) {
			op = jQuery.extend(op, opts.colModel.formatoptions);
		}
		var rowid = opts.rowId, str = "", ocl;
		if (typeof (rowid) == 'undefined' || jQuery.fmatter.isEmpty(rowid)) {
			return "";
		}
		if (op.activoButton) {
			var estado = rwd['cesta20'];
			
			if ( estado == 4){
				str = "<div><img src='"
					+ $.rup.APP_STATICS
					+ "/images/expBaja.png' width='15px' height='15px' alt='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "' title='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "'/></div>";
			}else if( estado == 2){
				str = "<div><img src='"
					+ $.rup.APP_STATICS
					+ "/images/expCerradoNoIncluido.png' width='15px' height='15px' alt='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "' title='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "'/></div>";
			}else if( estado == 1){
				str = "<div><img src='"
					+ $.rup.APP_STATICS
					+ "/images/expCerrado2.png' width='15px' height='15px' alt='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "' title='"
					+ $.rup.i18n.app.botonerasMantGenerales.nuevo
					+ "'/></div>";
			}
		}
	}
	
	return str;
};

function btn_abrirBusquedaJerarqTiposExp(valor){
	dialogoJerarqTiposExp.abrirDialogo(valor);
}
